"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""


from io import BytesIO
import struct

import drake

class lcmt_planar_gripper_status(object):
    """
    The current status of a planar-gripper.  All angular
    positions/velocities are expressed in radians and radians/second.
    """

    __slots__ = ["utime", "num_fingers", "finger_status"]

    __typenames__ = ["int64_t", "int8_t", "drake.lcmt_planar_gripper_finger_status"]

    __dimensions__ = [None, None, ["num_fingers"]]

    def __init__(self):
        self.utime = 0
        """
        The timestamp in microseconds (this is typically the wall clock
        time of the sender https://en.wikipedia.org/wiki/Unix_time )
        LCM Type: int64_t
        """

        self.num_fingers = 0
        """
        The planar gripper consists of N fingers, each finger consists of two
        actuated joints.
        LCM Type: int8_t
        """

        self.finger_status = []
        """ LCM Type: drake.lcmt_planar_gripper_finger_status[num_fingers] """

    def encode(self):
        buf = BytesIO()
        buf.write(lcmt_planar_gripper_status._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        buf.write(struct.pack(">qb", self.utime, self.num_fingers))
        for i0 in range(self.num_fingers):
            assert self.finger_status[i0]._get_packed_fingerprint() == drake.lcmt_planar_gripper_finger_status._get_packed_fingerprint()
            self.finger_status[i0]._encode_one(buf)

    @staticmethod
    def decode(data: bytes):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != lcmt_planar_gripper_status._get_packed_fingerprint():
            raise ValueError("Decode error")
        return lcmt_planar_gripper_status._decode_one(buf)

    @staticmethod
    def _decode_one(buf):
        self = lcmt_planar_gripper_status()
        self.utime, self.num_fingers = struct.unpack(">qb", buf.read(9))
        self.finger_status = []
        for i0 in range(self.num_fingers):
            self.finger_status.append(drake.lcmt_planar_gripper_finger_status._decode_one(buf))
        return self

    @staticmethod
    def _get_hash_recursive(parents):
        if lcmt_planar_gripper_status in parents: return 0
        newparents = parents + [lcmt_planar_gripper_status]
        tmphash = (0xec829b900fe84fe3+ drake.lcmt_planar_gripper_finger_status._get_hash_recursive(newparents)) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff) + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _packed_fingerprint = None

    @staticmethod
    def _get_packed_fingerprint():
        if lcmt_planar_gripper_status._packed_fingerprint is None:
            lcmt_planar_gripper_status._packed_fingerprint = struct.pack(">Q", lcmt_planar_gripper_status._get_hash_recursive([]))
        return lcmt_planar_gripper_status._packed_fingerprint

    def get_hash(self):
        """Get the LCM hash of the struct"""
        return struct.unpack(">Q", lcmt_planar_gripper_status._get_packed_fingerprint())[0]

